/************************************************************************
    filename:   TS_LayoutInternal.h
		created:    27/10/2005
		author:     martin FLEURENT
*************************************************************************/
#ifndef _TS_LayoutInternal_h_
#define _TS_LayoutInternal_h_

#include "CEGUI.h"
#include "TS_SkinHelper.h"
#include "TS_Menu.h"
#include "TS_SkinSelector.h"
#include "TS_LayoutSelector.h"
#include "TS_LayoutItems.h"


/*!
\brief
    class for the Skin Selector window
*/
class TSLayoutInternal
{
public:
    TSLayoutInternal();
    ~TSLayoutInternal();

		CEGUI::Window* build();

		bool setLayout(CEGUI::Window* rootLayout);
		//bool setBackgroundColour(const CEGUI::colour& backcolour);
		
		// want to have shortcuts
		bool handleKeyDown(const CEGUI::EventArgs& args);

		TSLayoutSelector* _selectorLayout;
		TSSkinSelector* _selectorSkin;
		TSBackgroundSelector* _selectorBackground;

private:

    CEGUI::StaticImage* d_root;
		CEGUI::FrameWindow* d_toolbox;
    CEGUI::DefaultWindow* d_layout;
		TSMenu* _Menu;
		TSAbout* _wndAbout;
		TSHelp* _wndHelp;
};





#endif  // end of guard _TS_LayoutInternal_h_
