/************************************************************************
    filename:   TS_LayoutSelector.h
		created:    22/10/2005
		author:     martin FLEURENT
*************************************************************************/
#ifndef _TS_LayoutSelector_h_
#define _TS_LayoutSelector_h_

#include "CEGUI.h"
#include "CEGUICommonFileDialog.h"
#include "TS_AppliConfig_xmlHandler.h"



/*!
\brief
    class for the Skin Selector window
*/
class TSLayoutSelector
{
public:
    TSLayoutSelector();
    ~TSLayoutSelector();

		CEGUI::Window* build();
	//	CEGUI::Window* load();

		void manageDelXmlState();
		bool fillXmlLayoutsList(const TSAppliConfig_xmlHandler::LayoutsStack layoutsList);

		bool handleRadioButtons(const CEGUI::EventArgs& e);
		bool handleAddXmlLayout(const CEGUI::EventArgs& e);
		bool handleDelXmlLayout(const CEGUI::EventArgs& e);
		bool handleLoadLayout(const CEGUI::EventArgs& e);
		//bool handleXmlLayoutsListbox(const CEGUI::EventArgs& e);
		bool handleFileDialogOutput(const CEGUI::EventArgs& args);

protected:
		CEGUI::StaticText*  _txtLayoutChoice;
		CEGUI::RadioButton* _radiobuttonFromeFile;
		CEGUI::RadioButton* _radiobuttonBuilIn;

		CEGUI::Listbox*     _wndBuildInLayoutListbox;

		CEGUI::ButtonBase*  _buttonXmlAdd;
		CEGUI::ButtonBase*  _buttonXmlDel;
		CEGUI::Listbox*     _wndXmlLayoutListbox;

		CEGUI::ButtonBase*  _buttonLoad;
};


#endif  // end of guard _TS_LayoutSelector_h_
