/************************************************************************
filename:   TS_SkinHelper.h
created:    22/10/2005
author:     martin FLEURENT
*************************************************************************/
#ifndef _TS_SkinHelper_h_
#define _TS_SkinHelper_h_

#include "CEGUI.h"
#include <vector>

/*!
\brief
widgets name navigate class
*/
class Widgets
{
public:
	Widgets();
	~Widgets(){};

	// method to initialise a new widget name set from a looknfeel.
	bool init();

	CEGUI::String Button;
	CEGUI::String CheckboxButton;
	CEGUI::String ComboDropList;
	CEGUI::String Combobox;
	CEGUI::String Editbox;
	CEGUI::String FrameWindow;
	CEGUI::String HorizontalScrollbar;
	CEGUI::String HorizontalScrollbarThumb;
	CEGUI::String IconButton;
	CEGUI::String ListHeader;
	CEGUI::String ListHeaderSegment;
	CEGUI::String Listbox;
	CEGUI::String Menubar;
	CEGUI::String MenuItem;
	CEGUI::String MultiColumnList;
	CEGUI::String MultiLineEditbox;
	CEGUI::String PopupMenu;
	CEGUI::String ProgressBar;
	CEGUI::String RadioButton;
	CEGUI::String ScrollablePane;
	CEGUI::String Slider;
	CEGUI::String SliderThumb;
	CEGUI::String Spinner;
	CEGUI::String StaticImage;
	CEGUI::String StaticText;
	CEGUI::String CloseButton;
	CEGUI::String TabButton;
	CEGUI::String TabControl;
	CEGUI::String TabPane;
	CEGUI::String Titlebar;
	CEGUI::String Tooltip;
	CEGUI::String VerticalScrollbar;
	CEGUI::String VerticalScrollbarThumb;
	CEGUI::String DefaultWindow;

};


/*!
\brief
Skin name navigate class
*/
class SkinInfo
{
public:
	SkinInfo(
		CEGUI::String SkinScheme,
		CEGUI::String SkinAliasScheme,
		CEGUI::String SkinLooknfeel,
		CEGUI::String SkinDefaultMouse
		);
	SkinInfo(
		CEGUI::String SkinFont,
		CEGUI::String SkinScheme,
		CEGUI::String SkinAliasScheme,
		CEGUI::String SkinLooknfeel,
		CEGUI::String SkinDefaultMouse
		);
	~SkinInfo(){};
	CEGUI::String name_file_Font;
	CEGUI::String name_file_SkinScheme;
	CEGUI::String name_file_SkinAliasScheme;
	CEGUI::String name_SkinLooknfeel;
	CEGUI::String name_SkinDefaultMouse;
};
/*!
\brief
Skin name navigate class
*/
class Skin
{
public:
	Skin();
	~Skin(){};

	typedef std::vector<SkinInfo*>	SkinsStack;

	// method to initialise a new Skin.
	bool init(SkinsStack skinsList);
	bool setSkin(CEGUI::uint id);

	SkinInfo* _skinUsed;

	SkinsStack _skinsList;

	Widgets name_Widgets;
	CEGUI::Imageset* imageset_Internal;

private:
		/*************************************************************************
		Implementation Constants
	*************************************************************************/
	static const CEGUI::String imagesetInternalFile;				//!< Tag name for CEGUIConfig elements.
};


/*!
\brief
Extremely simple example console class
*/
class SkinHelper
{
public:
	SkinHelper(){}
	~SkinHelper(){}

	// a kind of skin navigator
	static Skin usedSkin;
};


// Sample sub-class for ListboxTextItem that auto-sets the selection brush
// image.  This saves doing it manually every time in the code.
class MyListItem : public CEGUI::ListboxTextItem
{
public:
	MyListItem(const CEGUI::String& text);
	~MyListItem();
};



#endif  // end of guard _TS_SkinHelper_h_
