
/************************************************************************
filename:   TS_LayoutItems.cpp
created:    22/10/2005
author:     martin FLEURENT
*************************************************************************/
#include "TS_LayoutItems.h"
#include "CEGUI.h"
#include "TS_SkinHelper.h"

//////////////////////////////////////////////////////////////////////////
/*************************************************************************
TSAbout class
*************************************************************************/
//////////////////////////////////////////////////////////////////////////
TSAbout::TSAbout():
_handle(0)
{
}
TSAbout::~TSAbout()
{
}

CEGUI::Window* TSAbout::build()
{
	// Get window manager which we wil use for a few jobs here.
	CEGUI::WindowManager& winMgr = CEGUI::WindowManager::getSingleton();

	const Widgets& SkinWidgets = SkinHelper::usedSkin.name_Widgets;

	using namespace CEGUI;
	/*************************************************************************
	create main frame window
	*************************************************************************/
	CEGUI::FrameWindow* wndAbout = static_cast<CEGUI::FrameWindow*>(winMgr.createWindow(SkinWidgets.FrameWindow, "Root/wndAbout"));
	wndAbout->setWindowPosition(UVector2(UDim( 0.5f, -100.0f), UDim( 0.5f, -75.0f)));
	wndAbout->setWindowSize(UVector2(UDim( 0.0f, 200.0f), UDim( 0.0f, 150.0f)));
	wndAbout->setText("About TestaSkin");
	wndAbout->setAlwaysOnTop(true);
	wndAbout->hide();

	wndAbout->subscribeEvent(FrameWindow::EventCloseClicked, Event::Subscriber(&TSAbout::handleOk, this));
	
	/*************************************************************************
	create StaticText window without background
	*************************************************************************/
	CEGUI::StaticText* wndStaticText = static_cast<CEGUI::StaticText*>(winMgr.createWindow(SkinWidgets.StaticText, "Root/wndAbout/staticTextColored"));
	wndAbout->addChildWindow(wndStaticText);
	wndStaticText->setWindowPosition(UVector2(UDim( 0.0f, 5.0f), UDim( 0.0f, 30.0f)));
	wndStaticText->setWindowSize(UVector2(UDim( 1.0f, -10.0f), UDim( 1.0f, -60.0f)));
	wndStaticText->setText("TestaSkin v0.1");
	wndStaticText->setHorizontalFormatting(CEGUI::StaticText::HorzFormatting::WordWrapCentred);
	wndStaticText->setBackgroundEnabled(false);
	wndStaticText->setTextColours(colour(0.0f, 0.0f, 0.0f));

	/*************************************************************************
	create Quit Button window
	*************************************************************************/
	CEGUI::ButtonBase* wndButtonOk = static_cast<CEGUI::ButtonBase*>(winMgr.createWindow(SkinWidgets.Button, "Root/wndAbout/buttonOk"));
	wndAbout->addChildWindow(wndButtonOk);
	wndButtonOk->setWindowPosition(UVector2(UDim( 1.0f, -65.0f), UDim( 1.0f, -35.0f)));
	wndButtonOk->setWindowSize(UVector2(UDim( 0.0f, 60.0f), UDim( 0.0f, 30.0f)));
	wndButtonOk->setText("Ok");

	// suscribe event for the ok button
	wndButtonOk->subscribeEvent(ButtonBase::EventMouseClick, Event::Subscriber(&TSAbout::handleOk, this));

	_handle = wndAbout;
	return _handle;
}


bool TSAbout::handleOk(const CEGUI::EventArgs& e)
{
	// signal 
	_handle->hide();
	_handle->setModalState(false);
	
	// event was handled
	return true;
}


//////////////////////////////////////////////////////////////////////////
/*************************************************************************
TSHelp class
*************************************************************************/
//////////////////////////////////////////////////////////////////////////

TSHelp::TSHelp():
_handle(0)
{
}
TSHelp::~TSHelp()
{
}

CEGUI::Window* TSHelp::build()
{
	// Get window manager which we wil use for a few jobs here.
	CEGUI::WindowManager& winMgr = CEGUI::WindowManager::getSingleton();

	const Widgets& SkinWidgets = SkinHelper::usedSkin.name_Widgets;

	using namespace CEGUI;
	/*************************************************************************
	create main frame window
	*************************************************************************/
	CEGUI::FrameWindow* wndHelp = static_cast<CEGUI::FrameWindow*>(winMgr.createWindow(SkinWidgets.FrameWindow, "Root/wndHelp"));
	wndHelp->setWindowPosition(UVector2(UDim( 0.5f, -200.0f), UDim( 0.5f, -150.0f)));
	wndHelp->setWindowSize(UVector2(UDim( 0.0f, 400.0f), UDim( 0.0f, 300.0f)));
	wndHelp->setText("Help");
	wndHelp->setAlwaysOnTop(true);
	wndHelp->hide();

	wndHelp->subscribeEvent(FrameWindow::EventCloseClicked, Event::Subscriber(&TSHelp::handleOk, this));
	
	/*************************************************************************
	create StaticText window without background
	*************************************************************************/
	CEGUI::MultiLineEditbox* wndStaticText = static_cast<CEGUI::MultiLineEditbox*>(winMgr.createWindow(SkinWidgets.MultiLineEditbox, "Root/wndHelp/staticTextColored"));
	wndHelp->addChildWindow(wndStaticText);
	wndStaticText->setWindowPosition(UVector2(UDim( 0.0f, 5.0f), UDim( 0.0f, 30.0f)));
	wndStaticText->setWindowSize(UVector2(UDim( 1.0f, -10.0f), UDim( 1.0f, -60.0f)));
	wndStaticText->setText("This is the help window for the app");
	wndStaticText->disable();
	//wndStaticText->setTextColours(colour(1.0f, 1.0f, 1.0f));

	/*************************************************************************
	create Quit Button window
	*************************************************************************/
	CEGUI::ButtonBase* wndButtonOk = static_cast<CEGUI::ButtonBase*>(winMgr.createWindow(SkinWidgets.Button, "Root/wndHelp/buttonOk"));
	wndHelp->addChildWindow(wndButtonOk);
	wndButtonOk->setWindowPosition(UVector2(UDim( 1.0f, -65.0f), UDim( 1.0f, -35.0f)));
	wndButtonOk->setWindowSize(UVector2(UDim( 0.0f, 60.0f), UDim( 0.0f, 30.0f)));
	wndButtonOk->setText("Ok");

	// suscribe event for the ok button
	wndButtonOk->subscribeEvent(ButtonBase::EventMouseClick, Event::Subscriber(&TSHelp::handleOk, this));

	_handle = wndHelp;
	return _handle;
}


bool TSHelp::handleOk(const CEGUI::EventArgs& e)
{
	// signal 
	_handle->hide();
	_handle->setModalState(false);
	
	// event was handled
	return true;
}


//////////////////////////////////////////////////////////////////////////
/*************************************************************************
TSBackgroundSelector class
*************************************************************************/
//////////////////////////////////////////////////////////////////////////

TSBackgroundSelector::TSBackgroundSelector():
_handle(0)
{
}
TSBackgroundSelector::~TSBackgroundSelector()
{
}

CEGUI::Window* TSBackgroundSelector::build()
{
	using namespace CEGUI;
	// Get window manager which we wil use for a few jobs here.
	WindowManager& winMgr = WindowManager::getSingleton();

	const Widgets& SkinWidgets = SkinHelper::usedSkin.name_Widgets;

	//CEGUI::System::getSingleton().subscribeEvent(CEGUI::System::EventNam

	/*************************************************************************
	create BackgroundSelector frame window
	*************************************************************************/
	FrameWindow* wndBackgroundSelector = static_cast<FrameWindow*>(winMgr.createWindow(SkinWidgets.FrameWindow, "Root/wndBackgroundSelector"));
	//wndSkinSelector->setClippedByParent(false);
	wndBackgroundSelector->setWindowPosition(UVector2(UDim( 0.0f, 0.0f), UDim( 0.65f, 0.0f)));
	wndBackgroundSelector->setWindowSize(UVector2(UDim( 1.0f, 0.0f), UDim( 0.0f, 100.0f)));
	wndBackgroundSelector->setWindowMaxSize(UVector2(UDim( 1.0f, 0.0f), UDim( 1.0f, -40.0f)));
	wndBackgroundSelector->setWindowMinSize(UVector2(UDim( 0.0f, 150.0f), UDim( 0.0f, 100.0f)));
	wndBackgroundSelector->setText("Background");
	wndBackgroundSelector->setCloseButtonEnabled(false);
	wndBackgroundSelector->setDragMovingEnabled(false);
	//wndBackgroundSelector->setRollupEnabled(true);

	/*************************************************************************
	create ImageBackground window without background
	*************************************************************************/
	_wndStaticImage = static_cast<CEGUI::StaticImage*>(winMgr.createWindow(SkinWidgets.StaticImage, "Root/wndBackgroundSelector/staticImageBackground"));
	wndBackgroundSelector->addChildWindow(_wndStaticImage);
	_wndStaticImage->setWindowPosition(UVector2(UDim( 1.0f, -70.0f), UDim( 0.0f, 30.0f)));
	_wndStaticImage->setWindowSize(UVector2(UDim( 0.0f, 65.0f), UDim( 0.0f, 65.0f)));
	_wndStaticImage->setFrameEnabled(true);
	_wndStaticImage->setBackgroundEnabled(false);
	_wndStaticImage->setImage( "TestaSkinInternal", "ColorWhite");
	_wndStaticImage->setImageColours(colour(0.6f, 0.6f, 0.6f));

	/*************************************************************************
	create StaticText window without background
	*************************************************************************/
	CEGUI::StaticText* wndStaticTextRed = static_cast<CEGUI::StaticText*>(winMgr.createWindow(SkinWidgets.StaticText, "Root/wndBackgroundSelector/wndStaticTextRed"));
	wndBackgroundSelector->addChildWindow(wndStaticTextRed);
	wndStaticTextRed->setWindowPosition(UVector2(UDim( 0.0f, 5.0f), UDim( 0.0f, 30.0f)));
	wndStaticTextRed->setWindowSize(UVector2(UDim( 0.0f, 65.0f), UDim( 0.0f, 25.0f)));
	wndStaticTextRed->setText("Red");
	wndStaticTextRed->setBackgroundEnabled(false);
	wndStaticTextRed->setHorizontalFormatting(CEGUI::StaticText::HorzFormatting::RightAligned);
	wndStaticTextRed->setTextColours(colour(1.0f, 0.0f, 0.0f));

	/*************************************************************************
	create Spinner window
	*************************************************************************/
	_wndSpinnerRed = static_cast<CEGUI::Spinner*>(winMgr.createWindow(SkinWidgets.Spinner, "Root/wndBackgroundSelector/wndSpinnerRed"));
	wndBackgroundSelector->addChildWindow(_wndSpinnerRed);
	_wndSpinnerRed->setWindowPosition(UVector2(UDim( 0.0f, 65.0f), UDim( 0.0f, 30.0f)));
	_wndSpinnerRed->setWindowSize(UVector2(UDim( 1.0f, -135.0f), UDim( 0.0f, 25.0f)));
	_wndSpinnerRed->setMinimumValue(0);
	_wndSpinnerRed->setMaximumValue(255);
	_wndSpinnerRed->setCurrentValue(153);
	// suscribe event for the ok button
	_wndSpinnerRed->subscribeEvent(Spinner::EventValueChanged, Event::Subscriber(&TSBackgroundSelector::handleColour, this));
	
	/*************************************************************************
	create StaticText window without background
	*************************************************************************/
	CEGUI::StaticText* wndStaticTextGreen = static_cast<CEGUI::StaticText*>(winMgr.createWindow(SkinWidgets.StaticText, "Root/wndBackgroundSelector/wndStaticTextGreen"));
	wndBackgroundSelector->addChildWindow(wndStaticTextGreen);
	wndStaticTextGreen->setWindowPosition(UVector2(UDim( 0.0f, 5.0f), UDim( 0.0f, 50.0f)));
	wndStaticTextGreen->setWindowSize(UVector2(UDim( 0.0f, 65.0f), UDim( 0.0f, 25.0f)));
	wndStaticTextGreen->setText("Green");
	wndStaticTextGreen->setBackgroundEnabled(false);
	wndStaticTextGreen->setHorizontalFormatting(CEGUI::StaticText::HorzFormatting::RightAligned);
	wndStaticTextGreen->setTextColours(colour(0.0f, 1.0f, 0.0f));

	/*************************************************************************
	create Spinner window
	*************************************************************************/
	_wndSpinnerGreen = static_cast<CEGUI::Spinner*>(winMgr.createWindow(SkinWidgets.Spinner, "Root/wndBackgroundSelector/wndSpinnerGreen"));
	wndBackgroundSelector->addChildWindow(_wndSpinnerGreen);
	_wndSpinnerGreen->setWindowPosition(UVector2(UDim( 0.0f, 65.0f), UDim( 0.0f, 50.0f)));
	_wndSpinnerGreen->setWindowSize(UVector2(UDim( 1.0f, -135.0f), UDim( 0.0f, 25.0f)));
	_wndSpinnerGreen->setMinimumValue(0);
	_wndSpinnerGreen->setMaximumValue(255);
	_wndSpinnerGreen->setCurrentValue(153);
	// suscribe event for the ok button
	_wndSpinnerGreen->subscribeEvent(Spinner::EventValueChanged, Event::Subscriber(&TSBackgroundSelector::handleColour, this));


	/*************************************************************************
	create StaticText window without background
	*************************************************************************/
	CEGUI::StaticText* wndStaticTextBlue = static_cast<CEGUI::StaticText*>(winMgr.createWindow(SkinWidgets.StaticText, "Root/wndBackgroundSelector/wndStaticTextBlue"));
	wndBackgroundSelector->addChildWindow(wndStaticTextBlue);
	wndStaticTextBlue->setWindowPosition(UVector2(UDim( 0.0f, 5.0f), UDim( 0.0f, 70.0f)));
	wndStaticTextBlue->setWindowSize(UVector2(UDim( 0.0f, 65.0f), UDim( 0.0f, 25.0f)));
	wndStaticTextBlue->setText("Blue");
	wndStaticTextBlue->setBackgroundEnabled(false);
	wndStaticTextBlue->setHorizontalFormatting(CEGUI::StaticText::HorzFormatting::RightAligned);
	wndStaticTextBlue->setTextColours(colour(0.0f, 0.0f, 1.0f));

	/*************************************************************************
	create Spinner window
	*************************************************************************/
	_wndSpinnerBlue = static_cast<CEGUI::Spinner*>(winMgr.createWindow(SkinWidgets.Spinner, "Root/wndBackgroundSelector/wndSpinnerBlue"));
	wndBackgroundSelector->addChildWindow(_wndSpinnerBlue);
	_wndSpinnerBlue->setWindowPosition(UVector2(UDim( 0.0f, 65.0f), UDim( 0.0f, 70.0f)));
	_wndSpinnerBlue->setWindowSize(UVector2(UDim( 1.0f, -135.0f), UDim( 0.0f, 25.0f)));
	_wndSpinnerBlue->setMinimumValue(0);
	_wndSpinnerBlue->setMaximumValue(255);
	_wndSpinnerBlue->setCurrentValue(153);
	// suscribe event for the ok button
	_wndSpinnerBlue->subscribeEvent(Spinner::EventValueChanged, Event::Subscriber(&TSBackgroundSelector::handleColour, this));


	//
	_handle = wndBackgroundSelector;
	return _handle;
}


bool TSBackgroundSelector::handleColour(const CEGUI::EventArgs& e)
{
	// signal 
	CEGUI::colour background(
		_wndSpinnerRed->getCurrentValue() / 255.0f,
		_wndSpinnerGreen->getCurrentValue() / 255.0f,
		_wndSpinnerBlue->getCurrentValue() / 255.0f
	);

	_wndStaticImage->setImageColours(background);
	static_cast<CEGUI::StaticImage*>(CEGUI::WindowManager::getSingleton().getWindow("Root"))->
		setBackgroundColours(background);
	
	// event was handled
	return true;
}

bool TSBackgroundSelector::setColour(const CEGUI::colour& backcolour)
{
	// signal 
	_wndSpinnerRed->setCurrentValue(backcolour.getRed() * 255);
	_wndSpinnerGreen->setCurrentValue(backcolour.getGreen() * 255);
	_wndSpinnerBlue->setCurrentValue(backcolour.getBlue() * 255);


	_wndStaticImage->setImageColours(backcolour);
	static_cast<CEGUI::StaticImage*>(CEGUI::WindowManager::getSingleton().getWindow("Root"))->
		setBackgroundColours(backcolour);
	
	return true;
}