/************************************************************************
filename:   TS_LayoutToTest.cpp
created:    22/10/2005
author:     martin FLEURENT
*************************************************************************/
#include "TS_LayoutToTest.h"
#include "CEGUI.h"

#include "TS_SkinSelector.h"
#include "TS_LayoutSelector.h"


//////////////////////////////////////////////////////////////////////////
/*************************************************************************
TSLayoutToTest class
*************************************************************************/
//////////////////////////////////////////////////////////////////////////

TSLayoutToTest::TSLayoutToTest() :
d_rootLayoutToTest(0),
_pathLayoutFile("none")
{	
	_StaticTest = new TSStaticTest();
}

CEGUI::Window* TSLayoutToTest::build()
{
	using namespace CEGUI;

	_cleanup();

	// create and add the statictest
	d_rootLayoutToTest->addChildWindow(_StaticTest->build());

	return d_rootLayoutToTest;

}

CEGUI::Window* TSLayoutToTest::build(const CEGUI::String& path_LayoutFile)
{
	using namespace CEGUI;
	_pathLayoutFile = path_LayoutFile;
	_cleanup();

	// create and add the statictest
	d_rootLayoutToTest->addChildWindow(WindowManager::getSingleton().loadWindowLayout(_pathLayoutFile));

	return d_rootLayoutToTest;

}
TSLayoutToTest::~TSLayoutToTest()
{
	// destroy the windows that we loaded earlier
	CEGUI::WindowManager::getSingleton().destroyWindow(d_rootLayoutToTest);
	d_rootLayoutToTest = 0;

	delete _StaticTest;
	_StaticTest = 0;
}


bool TSLayoutToTest::_cleanup()
{

	using namespace CEGUI;
	// Get window manager which we wil use for a few jobs here.
	WindowManager& winMgr = WindowManager::getSingleton();

	const Widgets& SkinWidgets = SkinHelper::usedSkin.name_Widgets;

	if(d_rootLayoutToTest != 0)
		winMgr.destroyWindow(d_rootLayoutToTest);

	/*************************************************************************
	create the guisheet
	*************************************************************************/
	// create the layout root
	d_rootLayoutToTest = static_cast<DefaultWindow*>(winMgr.createWindow(SkinWidgets.DefaultWindow, "RootLayoutToTest"));

	return true;
}