/************************************************************************
filename:   TS_Menu.cpp
created:    22/10/2005
author:     martin FLEURENT
*************************************************************************/
#include "TS_Menu.h"
#include "CEGUI.h"
#include "TS_SkinHelper.h"




TSMenu::TSMenu()
{
}
TSMenu::~TSMenu()
{
}

CEGUI::Window* TSMenu::build()
{
	// Get window manager which we wil use for a few jobs here.
	CEGUI::WindowManager& winMgr = CEGUI::WindowManager::getSingleton();

	const Widgets& SkinWidgets = SkinHelper::usedSkin.name_Widgets;

	using namespace CEGUI;	
	/*************************************************************************
	create a menu bar
	*************************************************************************/
	CEGUI::Menubar* _menuBar = static_cast<CEGUI::Menubar*>(winMgr.createWindow(SkinWidgets.Menubar, "Root/Menubar"));
	_menuBar->setWindowPosition(UVector2(cegui_reldim(0.0f), cegui_reldim( 0.0f)));
	_menuBar->setWindowSize(UVector2(cegui_reldim(1.0f), UDim( 0.0f, 30.0f)));
	_menuBar->setWindowMaxSize(UVector2(cegui_reldim(1.0f), UDim( 0.0f, 30.0f)));
	_menuBar->setWindowMinSize(UVector2(cegui_reldim(1.0f), UDim( 0.0f, 30.0f)));
	//_menuBar->setClippedByParent(false);

	/*************************************************************************
	create file menu item window and popupmenu and items
	*************************************************************************/
	CEGUI::MenuItem* _menuFile = static_cast<CEGUI::MenuItem*>(winMgr.createWindow(SkinWidgets.MenuItem, "Root/Menubar/File"));
	_menuFile->setText("File");
	_menuBar->addItem(_menuFile);

	// create file menu popup window
	CEGUI::PopupMenu* _popupmenuFile = static_cast<CEGUI::PopupMenu*>(winMgr.createWindow(SkinWidgets.PopupMenu, "Root/Menubar/File/popFile"));
	_menuFile->setPopupMenu(_popupmenuFile);

	// create exit popup item window
	CEGUI::MenuItem* _itemExit = static_cast<CEGUI::MenuItem*>(winMgr.createWindow(SkinWidgets.MenuItem, "Root/MenuBar/File/popFile/Exit"));
	_itemExit->setText("Exit");
	_popupmenuFile->addItem(_itemExit);


	/*************************************************************************
	create What menu item window and popupmenu and items
	*************************************************************************/
	CEGUI::MenuItem* _menuWhat = static_cast<CEGUI::MenuItem*>(winMgr.createWindow(SkinWidgets.MenuItem, "Root/Menubar/What"));
	_menuWhat->setText("?");
	_menuBar->addItem(_menuWhat);

	// create What menu popup window
	CEGUI::PopupMenu* _popupmenuWhat = static_cast<CEGUI::PopupMenu*>(winMgr.createWindow(SkinWidgets.PopupMenu, "Root/Menubar/What/popWhat"));
	_menuWhat->setPopupMenu(_popupmenuWhat);

	// create Help popup item window
	CEGUI::MenuItem* _itemHelp = static_cast<CEGUI::MenuItem*>(winMgr.createWindow(SkinWidgets.MenuItem, "Root/Menubar/What/popWhat/Help"));
	_itemHelp->setText("Help");
	_popupmenuWhat->addItem(_itemHelp);

	// create About popup item window
	CEGUI::MenuItem* _itemAbout = static_cast<CEGUI::MenuItem*>(winMgr.createWindow(SkinWidgets.MenuItem, "Root/Menubar/What/popWhat/About"));
	_itemAbout->setText("About...");
	_popupmenuWhat->addItem(_itemAbout);

	return _menuBar;
}