/************************************************************************
    filename:   TS_SkinHelper.cpp
		created:    22/10/2005
		author:     martin FLEURENT
*************************************************************************/
#include "TS_SkinHelper.h"
#include "CEGUI.h"



//////////////////////////////////////////////////////////////////////////
/*************************************************************************
TestaSkin class
*************************************************************************/
//////////////////////////////////////////////////////////////////////////
Skin SkinHelper::usedSkin = Skin();


//////////////////////////////////////////////////////////////////////////
/*************************************************************************
Widgets class
*************************************************************************/
//////////////////////////////////////////////////////////////////////////
Widgets::Widgets()
{
	init();
};

bool Widgets::init()
{
	Button =										"Button";
	CheckboxButton =						"CheckboxButton";
	ComboDropList =							"ComboDropList";
	Combobox =									"Combobox";
	Editbox =										"Editbox";
	FrameWindow =								"FrameWindow";
	HorizontalScrollbar =				"HorizontalScrollbar";
	HorizontalScrollbarThumb =	"HorizontalScrollbarThumb";
	IconButton =								"IconButton";
	ListHeader =								"ListHeader";
	ListHeaderSegment =					"ListHeaderSegment";
	Listbox =										"Listbox";
	Menubar =										"Menubar";
	MenuItem =									"MenuItem";
	MultiColumnList =						"MultiColumnList";
	MultiLineEditbox =					"MultiLineEditbox";
	PopupMenu =									"PopupMenu";
	ProgressBar =								"ProgressBar";
	RadioButton =								"RadioButton";
	ScrollablePane =						"ScrollablePane";
	Slider =										"Slider";
	SliderThumb =								"SliderThumb";
	Spinner =										"Spinner";
	StaticImage =								"StaticImage";
	StaticText =								"StaticText";
	CloseButton =								"CloseButton";
	TabButton =									"TabButton";
	TabControl =								"TabControl";
	TabPane =										"TabPane";
	Titlebar =									"Titlebar";
	Tooltip =										"Tooltip";
	VerticalScrollbar =					"VerticalScrollbar";
	VerticalScrollbarThumb =		"VerticalScrollbarThumb";
	DefaultWindow =							"DefaultWindow";

	return true;
};

//////////////////////////////////////////////////////////////////////////
/*************************************************************************
SkinInfo class
*************************************************************************/
//////////////////////////////////////////////////////////////////////////
SkinInfo::SkinInfo(
		CEGUI::String SkinScheme,
		CEGUI::String SkinAliasScheme,
		CEGUI::String SkinLooknfeel,
		CEGUI::String SkinDefaultMouse
		)
{
	name_file_SkinScheme = SkinScheme;
	name_file_SkinAliasScheme = SkinAliasScheme;
	name_SkinLooknfeel = SkinLooknfeel;
	name_SkinDefaultMouse = SkinDefaultMouse;
}

SkinInfo::SkinInfo(
		CEGUI::String SkinFont,
		CEGUI::String SkinScheme,
		CEGUI::String SkinAliasScheme,
		CEGUI::String SkinLooknfeel,
		CEGUI::String SkinDefaultMouse
		)
{
	name_file_Font = SkinFont;
	name_file_SkinScheme = SkinScheme;
	name_file_SkinAliasScheme = SkinAliasScheme;
	name_SkinLooknfeel = SkinLooknfeel;
	name_SkinDefaultMouse = SkinDefaultMouse;
}

//////////////////////////////////////////////////////////////////////////
/*************************************************************************
Skin class
*************************************************************************/
//////////////////////////////////////////////////////////////////////////


/*************************************************************************
    Implementation Constants
*************************************************************************/
const CEGUI::String Skin::imagesetInternalFile( (CEGUI::utf8*)"../datafiles/imagesets/TestaSkinInternal.imageset" );

Skin::Skin():
name_Widgets(),
imageset_Internal(0),
_skinUsed(0)
{	
}

bool Skin::init(SkinsStack skinsList)
{
	// some accessors
	CEGUI::ImagesetManager& ismgr		= CEGUI::ImagesetManager::getSingleton();
	imageset_Internal = ismgr.createImageset(imagesetInternalFile);
		

	// hard loading the internal Marti skin
	SkinInfo* skinMarti = new SkinInfo(
		"../datafiles/fonts/arial-12.font",
		"../datafiles/schemes/MartiSkin.scheme",
		"../datafiles/schemes/WidgetAliasesMarti.scheme",
		"Marti",
		"MouseArrow"
		);
		
	// add it to the skin list
	_skinsList.push_back(skinMarti);

	// Load the scheme to initialse the Marti Skin which we use in this sample
	CEGUI::SchemeManager::getSingleton().loadScheme(skinMarti->name_file_SkinScheme);

	// do the same as above for the config skin list
	for (size_t index = 0; index < skinsList.size(); index++)
	{
		// hacky copy
		_skinsList.push_back(skinsList[index]);
		// Load the scheme to initialse the Skin 
		CEGUI::SchemeManager::getSingleton().loadScheme(skinsList[index]->name_file_SkinScheme);
	//CEGUI::Logger::getSingleton().logEvent(skinsList[index]->name_file_SkinScheme + "_________________STAMP________________________");
	}

	setSkin(0);

	return true;
}
bool Skin::setSkin(CEGUI::uint id)
{

	_skinUsed = _skinsList[id];

	// unload the old alias set 
	if(CEGUI::SchemeManager::getSingleton().isSchemePresent(_skinUsed->name_SkinLooknfeel + "WidgetAliases"))
	{
		CEGUI::SchemeManager::getSingleton().unloadScheme(_skinUsed->name_SkinLooknfeel + "WidgetAliases");
	}
	// Load the scheme to initialse the alias set we want to use
	CEGUI::SchemeManager::getSingleton().loadScheme(_skinUsed->name_file_SkinAliasScheme);
	
	return true;
}


//////////////////////////////////////////////////////////////////////////
/*************************************************************************
MyListItem class
*************************************************************************/
//////////////////////////////////////////////////////////////////////////
MyListItem::MyListItem(const CEGUI::String& text) :
ListboxTextItem(text)
{
	setSelectionBrushImage("TestaSkinInternal", "SelectColor");
	setTextColours( CEGUI::colour(0.5f, 0.5f, 0.5f ));
		setTooltipText(text);

}
MyListItem::~MyListItem()
{
}

