/************************************************************************
filename:   TS_SkinSelector.cpp
created:    22/10/2005
author:     martin FLEURENT
*************************************************************************/
#include "TS_SkinSelector.h"
#include "CEGUI.h"
#include "TS_SkinHelper.h"




TSSkinSelector::TSSkinSelector()
{
}
TSSkinSelector::~TSSkinSelector()
{
}

CEGUI::Window* TSSkinSelector::build()
{
	using namespace CEGUI;

	// Get window manager which we wil use for a few jobs here.
	CEGUI::WindowManager& winMgr = CEGUI::WindowManager::getSingleton();

	const Widgets& SkinWidgets = SkinHelper::usedSkin.name_Widgets;

	/*************************************************************************
	create SkinSelector frame window
	*************************************************************************/
	FrameWindow* wndSkinSelector = static_cast<FrameWindow*>(winMgr.createWindow(SkinWidgets.FrameWindow, "Root/wndSkinSelector"));
	//wndSkinSelector->setClippedByParent(false);
	wndSkinSelector->setWindowPosition(UVector2(UDim( 0.0f, 0.0f), UDim( 0.4f, 0.0f)));
	wndSkinSelector->setWindowSize(UVector2(UDim( 1.0f, 0.0f), UDim( 0.25f, 0.0f)));
	wndSkinSelector->setWindowMaxSize(UVector2(UDim( 1.0f, 0.0f), UDim( 1.0f, -40.0f)));
	wndSkinSelector->setWindowMinSize(UVector2(UDim( 0.0f, 150.0f), UDim( 0.2f, 0.0f)));
	wndSkinSelector->setText("Skin");
	wndSkinSelector->setCloseButtonEnabled(false);
	wndSkinSelector->setDragMovingEnabled(false);
	//wndSkinSelector->setRollupEnabled(true);

	/*************************************************************************
	create Listbox window
	*************************************************************************/
	_wndSkinsListbox = static_cast<CEGUI::Listbox*>(winMgr.createWindow(SkinWidgets.Listbox, "Root/wndSkinSelector/listboxSelector"));
	wndSkinSelector->addChildWindow(_wndSkinsListbox);
	_wndSkinsListbox->setWindowPosition(UVector2(UDim( 0.0f, 5.0f), UDim( 0.0f, 30.0f)));
	_wndSkinsListbox->setWindowSize(UVector2(UDim( 1.0f, -10.0f), UDim( 1.0f, -62.0f)));
	_wndSkinsListbox->setText("Choose a Skin");

	/*************************************************************************
	create items for the SelectorListbox
	*************************************************************************/
/*	
	// Marti skin is hard coded
	SkinInfo* infoMarti = SkinHelper::usedSkin._skinsList[0];

	MyListItem * itmSkinMarti = new MyListItem(infoMarti->name_SkinLooknfeel);
	_wndSkinsListbox->addItem(itmSkinMarti);
	itmSkinMarti->setID(0);
	itmSkinMarti->setText(infoMarti->name_SkinLooknfeel);
*/
	/*************************************************************************
	create StaticText to tell the currently used skin
	*************************************************************************/
	CEGUI::StaticText* statictextUsedSkin = static_cast<CEGUI::StaticText*>(winMgr.createWindow(SkinWidgets.StaticText, "Root/wndSkinSelector/statictextUsedSkin"));
	wndSkinSelector->addChildWindow(statictextUsedSkin);
	statictextUsedSkin->setWindowPosition(UVector2(UDim( 0.0f, 5.0f), UDim(1.0f, -35.0f)));
	statictextUsedSkin->setWindowSize(UVector2(UDim( 1.0f, -70.0f), UDim( 0.0f, 30.0f)));
	statictextUsedSkin->setText(SkinHelper::usedSkin._skinUsed->name_SkinLooknfeel);
	statictextUsedSkin->setBackgroundEnabled(false);

	/*************************************************************************
	create OK Button window
	*************************************************************************/
	CEGUI::ButtonBase* wndButtonOK = static_cast<CEGUI::ButtonBase*>(winMgr.createWindow(SkinWidgets.Button, "Root/wndSkinSelector/buttonOK"));
	wndSkinSelector->addChildWindow(wndButtonOK);
	wndButtonOK->setWindowPosition(UVector2(UDim( 1.0f, -65.0f), UDim( 1.0f, -35.0f)));
	wndButtonOK->setWindowSize(UVector2(UDim( 0.0f, 60.0f), UDim( 0.0f, 30.0f)));
	wndButtonOK->setText("Switch");

	return wndSkinSelector;
}

bool TSSkinSelector::fillSkinsList(const Skin::SkinsStack skinsList)
{
		
	using namespace CEGUI;

	String skinName;

	for (size_t index = 0; index < skinsList.size(); index++)
	{
		// hacky name construction
		skinName = skinsList[index]->name_SkinLooknfeel;

	  //create xml layout list item and add it to the list
	  MyListItem * itmSkin = new MyListItem(skinName);
	  _wndSkinsListbox->addItem(itmSkin);
		//itmSkin->setUserData((void*)skinsList[itmSkin]);
	  itmSkin->setID(index);
	  itmSkin->setText(skinName);
	}
	
_wndSkinsListbox->getListboxItemFromIndex(0)->setSelected(true);

	return true;
}