
/************************************************************************
filename:   TS_StaticText.cpp
created:    22/10/2005
author:     martin FLEURENT
*************************************************************************/
#include "TS_StaticTest.h"
#include "CEGUI.h"
#include "TS_SkinHelper.h"


TSStaticTest::TSStaticTest()
{
}
TSStaticTest::~TSStaticTest()
{
}

CEGUI::Window* TSStaticTest::build()
{
	// Get window manager which we wil use for a few jobs here.
	CEGUI::WindowManager& winMgr = CEGUI::WindowManager::getSingleton();

	const Widgets& SkinWidgets = SkinHelper::usedSkin.name_Widgets;

	using namespace CEGUI;
	/*************************************************************************
	create main frame window
	*************************************************************************/
	CEGUI::FrameWindow* wndMain = static_cast<CEGUI::FrameWindow*>(winMgr.createWindow(SkinWidgets.FrameWindow, "Root/windowMain"));
	wndMain->setWindowPosition(UVector2(UDim( 0.0f, 5.0f), UDim( 0.0f, 5.0f)));
	wndMain->setWindowSize(UVector2(UDim( 1.0f, -10.0f), UDim( 1.0f, -10.0f)));
	wndMain->setWindowMaxSize(UVector2(UDim( 1.0f, 0.0f), UDim( 1.0f, -10.0f)));
	wndMain->setWindowMinSize(UVector2(UDim( 0.5f, 0.0f), UDim( 0.5f, 0.0f)));
	wndMain->setText("Static widgets test Window");

	/*************************************************************************
	create StaticText window with background on
	*************************************************************************/
	CEGUI::StaticText* wndStaticTextWithBackground = static_cast<CEGUI::StaticText*>(winMgr.createWindow(SkinWidgets.StaticText, "Root/windowMain/staticTextBackground"));
	wndMain->addChildWindow(wndStaticTextWithBackground);
	wndStaticTextWithBackground->setWindowPosition(UVector2(UDim( 0.0f, 5.0f), UDim( 0.0f, 40.0f)));
	wndStaticTextWithBackground->setWindowSize(UVector2(UDim( 1.0f, -140.0f), UDim( 0.0f, 35.0f)));
	wndStaticTextWithBackground->setText("a little static test with background");

	/*************************************************************************
	create StaticText window without background
	*************************************************************************/
	CEGUI::StaticText* wndStaticText = static_cast<CEGUI::StaticText*>(winMgr.createWindow(SkinWidgets.StaticText, "Root/windowMain/staticTextColored"));
	wndMain->addChildWindow(wndStaticText);
	wndStaticText->setWindowPosition(UVector2(UDim( 0.0f, 5.0f), UDim( 0.0f, 80.0f)));
	wndStaticText->setWindowSize(UVector2(UDim( 1.0f, -140.0f), UDim( 0.0f, 35.0f)));
	wndStaticText->setText("and one without but text colored");
	wndStaticText->setBackgroundEnabled(false);
	wndStaticText->setTextColours(colour(1.0f, 0.0f, 1.0f));

	/*************************************************************************
	create Editbox window
	*************************************************************************/
	CEGUI::Editbox* wndEditboxTest = static_cast<CEGUI::Editbox*>(winMgr.createWindow(SkinWidgets.Editbox, "Root/windowMain/editboxTest"));
	wndMain->addChildWindow(wndEditboxTest);
	wndEditboxTest->setWindowPosition(UVector2(UDim( 0.0f, 5.0f), UDim( 0.0f, 120.0f)));
	wndEditboxTest->setWindowSize(UVector2(UDim( 1.0f, -140.0f), UDim( 0.0f, 35.0f)));
	wndEditboxTest->setText("an Editbox to play with");
	
	/*************************************************************************
	create spinnerTest window with background on
	*************************************************************************/
/*	CEGUI::Spinner* spinnerTest = static_cast<CEGUI::Spinner*>(winMgr.createWindow(SkinWidgets.Spinner, "Root/windowMain/spinnerTest"));
	wndMain->addChildWindow(spinnerTest);
	spinnerTest->setWindowPosition(UVector2(UDim( 0.0f, 5.0f), UDim( 0.0f, 160.0f)));
	spinnerTest->setWindowSize(UVector2(UDim( 1.0f, -140.0f), UDim( 0.0f, 35.0f)));
	spinnerTest->setMaximumValue(255);
	spinnerTest->setMinimumValue(0);
	spinnerTest->setCurrentValue(125);
*/
	/*************************************************************************
	create Quit Button window
	*************************************************************************/
/*	CEGUI::ButtonBase* wndButtonQuit = static_cast<CEGUI::ButtonBase*>(winMgr.createWindow(SkinWidgets.Button, "Root/windowMain/buttonQuit"));
	wndMain->addChildWindow(wndButtonQuit);
	wndButtonQuit->setWindowPosition(UVector2(UDim( 1.0f, -70.0f), UDim( 1.0f, -35.0f)));
	wndButtonQuit->setWindowSize(UVector2(UDim( 0.0f, 60.0f), UDim( 0.0f, 25.0f)));
	wndButtonQuit->setText("Quit");
*/
	return wndMain;

}